#!/bin/sh

ROOT_FS="/mnt/fs_root"
FILES_BACKUP_FACTORY=""
FILES_BACKUP="etc/pointercal.small etc/pointercal.big etc/network/interfaces etc/resolv.conf etc/hostname etc/wpa_supplicant.conf $FILES_BACKUP_FACTORY"

TMP_FILE="/tmp/bk.tar"

FACTORY_RESET="true"


echo "Updating MAC..."
update-mac dtb_standard.bin dtb_standard.patched
echo "OK"

echo "Erasing DTB Standard... "
flash_eraseall /dev/mtd2
echo "OK"

echo "Flashing DTB Standard... "
nandwrite -p /dev/mtd2 dtb_standard.patched
echo "OK"

echo "Erasing Kernel Standard... "
flash_eraseall /dev/mtd4
echo "OK"

echo "Flashing Kernel Standard... "
nandwrite -p /dev/mtd4 kernel_standard.bin
echo "OK"

echo "Backing up files..."
ROOT_PASSWD=$(egrep -v '.*:\*|:\!' $ROOT_FS/etc/shadow | grep root | awk -F: '{print $2}')
if [ -f "FACTORY_RESET" ]; then
	tar -C $ROOT_FS -c $FILES_BACKUP_FACTORY -f $TMP_FILE
	rm -rf /mnt/fs_user/*
else
	tar -C $ROOT_FS -c $FILES_BACKUP -f $TMP_FILE
fi
echo "OK"

echo "Umounting Root File System..."
umount $ROOT_FS
echo "OK"

echo "Detaching Root File System..."
ubidetach -m 8
echo "OK"

echo "Formating Root File System..."
ubiformat /dev/mtd8 -y -f main.ubi
echo "OK"

echo "Attaching Root File System..."
ubiattach -p /dev/mtd8
echo "OK"

echo "Mounting Root File System..."
mount $ROOT_FS
echo "OK"

echo "Restoring files..."
tar -x -f $TMP_FILE -C $ROOT_FS
FILE_CONTENT=$(awk -F: "BEGIN {OFS=FS;} \$1 == \"root\" {\$2=\"$ROOT_PASSWD\"} 1" $ROOT_FS/etc/shadow)
echo -n "$FILE_CONTENT" > $ROOT_FS/etc/shadow
echo "OK"

echo "Cleanning up..."
rm $TMP_FILE
echo "OK"
